//+------------------------------------------------------------------+ 
//|                                                  WuWei v1.00.mq4 |
//|                                               copyright 2010 CJE |
//+------------------------------------------------------------------+

//v1.00: Original version


#property copyright "Copyright  2010 CJE"

extern int     AddPos      = 125;
extern int     RevPos      = 200;
extern int     TrailingStop= 20;
extern int     Direction   = 1;
extern double  Lots        = 0.01;
extern int     mm          = 1;

extern int     MagicNumber = 773325;

//int ticket;
int            LONG        = 1;
int            SHORT       = -1;
double         addPosition = 0;
double         revPosition = 0;
double         LastOrder   = 0;
double         FirstOrder  = 0;
bool           iTradeDirLong   = FALSE;
int            iLosses     = 0;
int            iPos        = 0;
int            cnt         = 0;
int            slippage    = 10;
int            ticket      = 0;
double         lotsi       = 0;
double         mylotsi     = 0;
bool           currInTrade = FALSE;
string         CurrentBuild= "v1.0";
bool           CloseAll    = false;

int init(){return(0);}
int deinit(){return(0);}

int start()
{
   int cnt = 0;
   
   
   
   
//1. Money management & trade sizing
   if (mm != 0)
      lotsi = MathRound(AccountBalance() * 0.0004) / 100; //deterimes lot size based on account size. Account balance times .0002/100.  $1,000 would start with .002 lots
   else
      lotsi = Lots;
   if (iPos == 0)   
   mylotsi = NormalizeDouble(lotsi * MathPow(2, iLosses), 2); //This is the doubling lot size effect of the program.  
   else
   mylotsi = NormalizeDouble(lotsi * MathPow(2, iLosses) * MathPow(2, iPos), 2);
   
   if (mylotsi > 100) mylotsi = 100;

   RefreshRates();
 int tickets[100]; double price[100]; datetime oot[100];
int count=0;
for(int index = OrdersTotal() - 1; index >= 0; index--) if (
        OrderSelect(index, SELECT_BY_POS)   // Only my orders w/
    &&  OrderMagicNumber()  == MagicNumber  // my magic number
    &&  OrderSymbol()       == Symbol() ) { // and period and symbol
    tickets[count]= OrderTicket(); 
    price[count] = OrderOpenPrice();
    oot[count]   = OrderOpenTime();
    count++;
}
int order[100];    // Insertion sort
for (int kk=0; kk<count; kk++) { // Keep ordering ticket[*], price[*] and oot[*]
    for (int ii=kk; ii>0 && oot[order[ii-1]] > oot[kk]; ii--) {
        order[ii]=order[ii-1];  // kk   oot[kk] order[kk]   oot[order[kk]]
    }                           // 0    3.      1           1.
    order[ii]=kk;               // 1    1.      2           2.
}                               // 2    2.      0           3.

 if(OrderSelect(10, SELECT_BY_POS)==true)
    Print("open price for the order 10 ",OrderOpenPrice());
       
FirstOrder = price[order[0]];  //     is the oldest
LastOrder = price[order[count-1]];// is the latest
   

   if (currInTrade == FALSE)//If not currently in a trade.  
   {
 
      if (iTradeDirLong == TRUE) //If Trademode says Long, then Buy, enter next position, and rev position limits.
      {
         
         addPosition = Ask + AddPos * Point;
         
         revPosition = iLow(NULL,PERIOD_H1,1)-(10*Point);
         ticket = OrderSend(Symbol(), OP_BUY, mylotsi, Ask, slippage, 0, 0, NULL, MagicNumber, 0, White);
         currInTrade = TRUE;
         Alert("Open #",ticket,"  InTrade = ",currInTrade);
         ObjectCreate("Add Position", OBJ_HLINE, 0, 0, addPosition);
         ObjectCreate("Reverse Position", OBJ_HLINE, 0, 0, revPosition);
         iPos=0;
         
      }
      else // If Trademode says short, then this
      {
         
         addPosition = Bid - AddPos * Point;
        
         revPosition = iHigh(NULL,PERIOD_H1,1)+(10*Point);
         ticket = OrderSend(Symbol(), OP_SELL, mylotsi, Bid, slippage, 0, 0, NULL, MagicNumber, 0, Red);
         currInTrade = TRUE;
         Alert("Open #",ticket,"  InTrade = ",currInTrade);
         ObjectCreate("Add Position", OBJ_HLINE, 0, 0, addPosition);
         ObjectCreate("Reverse Position", OBJ_HLINE, 0, 0, revPosition);
         iPos=0;
         
      }
   }
   
   if (iTradeDirLong == TRUE && currInTrade == TRUE)//When long, add position
   {
      if (Bid <= revPosition)
      {  
         for(int i=OrdersTotal()-1;i>=0;i--)
         {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
         continue;
         }
         Alert("Close #",ticket,"  InTrade = ",currInTrade);         
         ObjectDelete("Add Position");
         ObjectDelete("Reverse Position");
         iTradeDirLong = FALSE;
         currInTrade = FALSE;
         if (iPos > 0 || OrderProfit() > 0)
         { 
         iLosses = 0;
         }
         else
         {
         iLosses++;
         }
      }
      if (Bid >= addPosition && currInTrade == TRUE) // When long, reverse position
      {  
         
         addPosition = Ask + iPos * AddPos * Point;
         RefreshRates();
         revPosition = LastOrder;
         ticket = OrderSend(Symbol(), OP_BUY, mylotsi, Ask, slippage, 0, 0, NULL, MagicNumber, 0, White);
         Alert("Open #",ticket,"  InTrade = ",currInTrade);
         ObjectCreate("Add Position", OBJ_HLINE, 0, 0, addPosition);
         ObjectCreate("Reverse Position", OBJ_HLINE, 0, 0, revPosition);
         iPos++;
         
         
      }   
   /*  if (Bid > (RevPos * 2 * Point) + LastOrder && iTradeDirLong == TRUE && iPos == 0)
   revPosition = LastOrder + RevPos*Point*1.5;
   if (Bid > (AddPos/2 * Point) + LastOrder && iTradeDirLong == TRUE && iPos > 0)
   revPosition = LastOrder;
   if (Bid > (AddPos/2 * Point) + LastOrder && iTradeDirLong == TRUE && iPos > 0 )
   revPosition = LastOrder + AddPos/4*Point;
   if (Bid > (AddPos*4/5 * Point) + LastOrder && iTradeDirLong == TRUE && iPos > 0)
   revPosition = LastOrder + AddPos * 3/4 * Point;
   if (iPos > 8 && Bid > LastOrder + RevPos * Point)
   revPosition = Bid;*/
   }
  
   if (iTradeDirLong == FALSE && currInTrade == TRUE) // When short, add position
   {
      if (Ask >= revPosition)
      {
         for(int j=OrdersTotal()-1;j>=0;j--)
         {
         OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
         OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
         continue;
         }
         Alert("Close #",ticket,"  InTrade = ",currInTrade);         
         ObjectDelete("Add Position");
         ObjectDelete("Reverse Position");
         iTradeDirLong = TRUE;
         currInTrade = FALSE;
         if (iPos > 0 || OrderProfit() > 0)
            { 
            iLosses = 0;
            }
            else
            {
            iLosses++;
            }
      }
      if (Ask <= addPosition && currInTrade == TRUE) // When short, reverse psition.  
      {
         
         ticket = OrderSend(Symbol(), OP_SELL, mylotsi, Bid, slippage, 0, 0, NULL, MagicNumber, 0, Red);
         addPosition = Bid - iPos * AddPos * Point;
         revPosition = LastOrder;
         Alert("Open #",ticket,"  InTrade = ",currInTrade);
         ObjectCreate("Reverse Position", OBJ_HLINE, 0, 0, addPosition);
         ObjectCreate("Reverse Position", OBJ_HLINE, 0, 0, revPosition);
         iPos++;
        
         
       }
     /* if (Ask < LastOrder - (RevPos * 2 * Point) && iTradeDirLong == FALSE && iPos == 3)
   revPosition = LastOrder - RevPos * Point *1.5;
      if (Ask < LastOrder - (AddPos/2 * Point)  && iTradeDirLong == FALSE && iPos > 0)
   revPosition = LastOrder;
      if (Ask < LastOrder - (AddPos/2 * Point)  && iTradeDirLong == FALSE && iPos > 0)
   revPosition = LastOrder - AddPos/4 *  Point ;
      if (Ask < LastOrder - (AddPos*4/5 * Point)  && iTradeDirLong == FALSE && iPos > 0)
   revPosition = LastOrder - AddPos * 3/4 *  Point ;
   if (iPos > 8 && Ask < LastOrder - RevPos * Point)
   revPosition = Ask;*/
   }
   
  
   
   
   
   
   
           

   
   return(0);
}


